class A {
    public void foo (Object o) {
        System.out.println("A");
    }
}

class AA {
    public void foo (Object o) {
        System.out.println("AA");
    }
	public void foo (String s) {
		System.out.println("AA+");
	}
}

class B {
    public void foo (String s) {
        System.out.println("B");
    }
}

class C extends A {
    public void foo (Object o) {
        System.out.println("C");
    }
}

class CC extends AA {
    public void foo (Object o) {
        System.out.println("CC");
    }
	public void foo (String s) {
		System.out.println("CC+");
	}
}

class CCC extends A {
    public void foo (Object o) {
        System.out.println("CCC");
    }
	public void foo (String s) {
		System.out.println("CCC+");
	}
}

class D extends A {
    public void foo (String s) {
        System.out.println("D");
    }
}

class E extends B {
    public void foo (Object o) {
        System.out.println("E");
    }
}

class F extends B {
    public void foo (String s) {
        System.out.println("F");
    }
}

public class Task2 {
    
    public static void main(String args[]) {		
		A a = new A();				// the type of a is A
        a.foo("Java");				// A
		a.foo( new Object() );		// A
		
        A ac = new C();
		// the static type of ac is A and its dynamic type is C
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo() in A: public void foo (Object o)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (Object o) in C
        ac.foo("Java");				// C - overriding of A.foo() in C
		ac.foo( new Object() );		// C - overriding of A.foo() in C
		
        A ad = new D();				
		// the static type of ad is A and its dynamic type is D
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo() in A: public void foo (Object o)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (Object o) in D
		// (and does not find any in this case)
        ad.foo("Java");				// A
        ad.foo( new Object() );		// A
		
        C c = new C();          	// the type of c is C
        c.foo("Java");				// C
		c.foo( new Object() );		// C
		
        D d = new D();				// the type of d is D
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo("Java") in D: public void foo (String s)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (String s) in D
		// (and finds the same method in this case)
        d.foo("Java");				// D - overloading of A.foo() in D
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo(new Object()) in D: public void foo (Object o)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (Object o) in D
		// (and finds the same method in this case)
        d.foo( new Object() );		// A 
		
        B b = new B();          	// the type of b is B
        b.foo("Java");				// B
		//b.foo( new Object() );	// --- error: incompatible types
		
        B be = new E();				
		// the static type of be is B and its dynamic type is E
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo() in B: public void foo (String s)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (String s) in E
		// (and does not find any in this case)
        be.foo("Java");				// B
		//be.foo( new Object() );	// --- error: incompatible types
		
        B bf = new F();				
		// the static type of bf is B and its dynamic type is F
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo() in B: public void foo (String s)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (String s) in F
        bf.foo("Java");				// F - overriding
		//bf.foo( new Object() );	// --- error: incompatible types
		
        E e = new E();				// the type of e is E
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo("Java") in E: public void foo (String s)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (String s) in E
		// (and finds the same method in this case)
        e.foo("Java");				// B - overloading of B.foo() in E
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo(new Object()) in E: public void foo (Object o)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (Object o) in E
		// (and finds the same method in this case)
		e.foo( new Object() );		// E
		
        F f = new F();				// the type of f is F
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo() in F: public void foo (String s)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (String s) in F
		// (and finds the same method in this case)
        f.foo("Java");				// F - overriding
		//f.foo( new Object() );	// --- error: incompatible types
		
        AA aacc = new CC();			
		// the static type of aacc is AA and its dynamic type is CC
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo("Java") in AA: public void foo (String s)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (String s) in CC
        aacc.foo("Java");			// CC+
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo(new Object()) in AA: public void foo (Object o)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (Object o) in CC
		aacc.foo( new Object() );	// CC
		
        A accc = new CCC();
		// the static type of aacc is A and its dynamic type is CCC
		// overloading is resolved at compile time 
		// (with respect to the static type of the receiver):
		// Java searches for the most precise signature 
		// of the method foo() in A: public void foo (Object o)
		// overriding is resolved at run-time
		// (with respect to the dynamic type of the receiver):
		// Java searches for the override of the method foo()
		// with signature public void foo (Object o) in CC
        accc.foo("Java");			// CCC
		accc.foo( new Object() );	// CCC		
    }
	
}